#ifndef PW_CORE_MATH_HPP
#define PW_CORE_MATH_HPP

#include <cmath>

namespace pw {

const static double __PW_PI = 3.1415926535897932384626433832795028841971693993751058209;
const static double __RAD2DEG = 180.0 / __PW_PI;
const static double __DEG2RAD = __PW_PI / 180.0;


template <typename T>
inline const T pi() { return static_cast<T>(__PW_PI); }

template <typename T>
inline static T rad_to_deg(const T& angle_in_radian) {
	return angle_in_radian * __RAD2DEG;
}

template <typename T>
inline static T deg_to_rad(const T& angle_in_degree) {
	return angle_in_degree * __DEG2RAD;
}

}

#endif
