#ifndef PW_VISUAL_SHADER_HPP
#define PW_VISUAL_SHADER_HPP

#include <pw/core/globals.hpp>
#include <pw/core/matrix.hpp>

#include <map>

namespace pw {

class shader {
public:

	shader();

	enum code_type {
		vertex,				//<
		fragment,
		geometry,
		compute
	};

	void set_source(const std::string& c,code_type t);
	std::string source(code_type t) { return _source[t]; }

//	void set_attributes(const std::vector<std::string> > &attributes);

	bool ready() const;

protected:

	std::map<code_type,std::string> _source;

	struct impl;
	std::unique_ptr<impl> _impl;

};

}

#endif
